//+------------------------------------------------------------------+
//|                                        OnTick(string symbol).mqh |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                              Revision 2011.01.30 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Lizar"
#property link      "https://login.mql5.com/ru/users/Lizar"

//+------------------------------------------------------------------+
//|     ,     |
//|     .     |
//|      "|"                        |
//+------------------------------------------------------------------+
  
enum ENUM_CHART_EVENT_SYMBOL
  {
   CHARTEVENT_NO        =0,          //  
   CHARTEVENT_INIT      =0,          //  "" 
   
   CHARTEVENT_NEWBAR_M1 =0x00000001, //  " "  1 - 
   CHARTEVENT_NEWBAR_M2 =0x00000002, //  " "  2 - 
   CHARTEVENT_NEWBAR_M3 =0x00000004, //  " "  3 - 
   CHARTEVENT_NEWBAR_M4 =0x00000008, //  " "  4 - 
   
   CHARTEVENT_NEWBAR_M5 =0x00000010, //  " "  5 - 
   CHARTEVENT_NEWBAR_M6 =0x00000020, //  " "  6 - 
   CHARTEVENT_NEWBAR_M10=0x00000040, //  " "  10- 
   CHARTEVENT_NEWBAR_M12=0x00000080, //  " "  12- 
   
   CHARTEVENT_NEWBAR_M15=0x00000100, //  " "  15- 
   CHARTEVENT_NEWBAR_M20=0x00000200, //  " "  20- 
   CHARTEVENT_NEWBAR_M30=0x00000400, //  " "  30- 
   CHARTEVENT_NEWBAR_H1 =0x00000800, //  " "  1 - 
   
   CHARTEVENT_NEWBAR_H2 =0x00001000, //  " "  2 - 
   CHARTEVENT_NEWBAR_H3 =0x00002000, //  " "  3 - 
   CHARTEVENT_NEWBAR_H4 =0x00004000, //  " "  4 - 
   CHARTEVENT_NEWBAR_H6 =0x00008000, //  " "  6 - 
   
   CHARTEVENT_NEWBAR_H8 =0x00010000, //  " "  8 - 
   CHARTEVENT_NEWBAR_H12=0x00020000, //  " "  12- 
   CHARTEVENT_NEWBAR_D1 =0x00040000, //  " "   
   CHARTEVENT_NEWBAR_W1 =0x00080000, //  " "   
     
   CHARTEVENT_NEWBAR_MN1=0x00100000, //  " "      
   CHARTEVENT_TICK      =0x00200000, //  " "
   
   CHARTEVENT_ALL       =0xFFFFFFFF, //   
  };

//--- 
string _symbol_[]={SYMBOLS_TRADING};
int    _handle_[];

int    _symbols_total_  = 0;     //   
int    _symbols_market_ = 0;     //     " "
bool   _market_watch_   = false; //      " "
bool   _testing_        = false; //    

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   //---    -    :
   _testing_=((bool)MQL5InfoInteger(MQL5_TESTING) ||
              (bool)MQL5InfoInteger(MQL5_OPTIMIZATION) ||
              (bool)MQL5InfoInteger(MQL5_VISUAL_MODE));
              
   //--- :       " "
   if(_symbol_[0]=="MARKET_WATCH") _market_watch_=true;            
   
   //---   :
   if(_testing_ && _market_watch_)
     {
      Print(":         SYMBOLS_TRADING");
      return(1);
     }
     
   //---    :
   _symbols_total_=SymbolsTotal(false);      //   
   ArrayResize(_handle_,_symbols_total_);    //       ""
   ArrayInitialize(_handle_,INVALID_HANDLE); //      ""

   //---  "":
   if(_market_watch_) SynchronizationTradingTools();
   else
     {
      _symbols_total_=ArraySize(_symbol_);     
      for(int i=0;i<_symbols_total_;i++)
         if(!LoadAgent(i, _symbol_[i])) return(1);      
     }   
   
   //---   OnInit 
   _OnInit();      
   return(0);   
  }
#define OnInit _OnInit  //   OnInit 

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//|                        |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(_testing_)
     {
      for(int i=0;i<_symbols_total_;i++)
        {
         string __symbol__=_symbol_[i];
         if(MathAbs(GlobalVariableGet(__symbol__+"_flag")-2)<0.1) 
           {
            GlobalVariableSet(__symbol__+"_flag",1);
            OnTick(__symbol__);
           }
        }   
     }   
  }

//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long& lparam,const double& dparam,const string& sparam)
  {
   //---   OnTick(string symbol)  OnChartEvent:
   if(id==CHARTEVENT_CUSTOM_LAST) 
     {
      OnTick(sparam);
      //---    ""  " ": 
      if(_market_watch_) SynchronizationTradingTools();
     }
   else _OnChartEvent(id,lparam,dparam,sparam);
  }
#define OnChartEvent _OnChartEvent  //   OnChartEvent 

//+------------------------------------------------------------------+
//|    ""        |
//| " "                                                    |
//| INPUT:  no.                                                      |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void SynchronizationTradingTools()
  {
   if(_symbols_market_!=SymbolsTotal(true))
     {
      _symbols_market_=0;
      
      for(int i=0;i<_symbols_total_;i++)
        {      
         long __symbol_select__;
         string __symbol__=SymbolName(i,false);
         if(!SymbolInfoInteger(__symbol__,SYMBOL_SELECT,__symbol_select__)) return;
   
         if(_handle_[i]==INVALID_HANDLE && __symbol_select__)
           {
             if(!LoadAgent(i,__symbol__)) return;
           }
         else if(_handle_[i]!=INVALID_HANDLE  && !__symbol_select__)
           {
             if(!DeLoadAgent(i,__symbol__)) return;
           }
        }   
      _symbols_market_=SymbolsTotal(true);
     }
  }

//+------------------------------------------------------------------+
//|   ""                                       |
//| INPUT:  __id__     -  ,   |
//|                                |
//|         __symbol__ -                                   |
//| OUTPUT: true       -                        |
//|         false      -                                    |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
bool LoadAgent(int __id__, string __symbol__)
  {
   _handle_[__id__]=iCustom(__symbol__,_Period,"Spy Control panel MCM",ChartID(),65534,CHART_EVENT_SYMBOL);
   if(_handle_[__id__]==INVALID_HANDLE) 
     {
      Print("    ",__symbol__);
      return(false);  
     }
   Print("   ",__symbol__);
   return(true);  
  }  
  
//+------------------------------------------------------------------+
//|   ""                                       |
//| INPUT:  __id__     -  ,   |
//|                                |
//|         __symbol__ -                                   |
//| OUTPUT: true       -                        |
//|         false      -                                    |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
bool DeLoadAgent(int __id__, string __symbol__)
  {
   if(_handle_[__id__]!=INVALID_HANDLE)
     {
      if(!IndicatorRelease(_handle_[__id__]))
        {
         Print("    ",__symbol__);
         return(false);  
        }
      Print("   ",__symbol__);
      _handle_[__id__]=INVALID_HANDLE;
     }
   return(true);  
  }
  
//+------------------------------ end -------------------------------+